<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Offer extends Model
{
    use HasFactory;

    /**
     * অফারের কোন ফিল্ড গুলো fillable করা যাবে
     */
    protected $fillable = [
        'operator_id',
        'category_id',
        'logo',
        'title',
        'description',
        'price',
        'cashback',
        'validity',
    ];

    /**
     * অফার কোন অপারেটরের অধীনে তা দেখাবে
     */
    public function operator()
    {
        return $this->belongsTo(Operator::class);
    }

    /**
     * অফার কোন ক্যাটাগরির অধীনে তা দেখাবে
     */
    public function category()
    {
        return $this->belongsTo(Category::class);
    }

    /**
     * একটি অফারের অনেক অর্ডার থাকতে পারে
     */
    public function orders()
    {
        return $this->hasMany(Order::class);
    }
}